using System;
using System.Data.Odbc;

namespace AdoExample
{
	/// <summary>
	/// InserExample shows how to use insert in Ado.net. It also describes the usage of parameterized queries, prepared
	/// execution and transaction handling
	/// </summary>
	public class InsertTransExample
	{
		private ExampleErrorHelper eeh;
		public InsertTransExample()
		{
			eeh = new ExampleErrorHelper();
		}

		public void insertBooks()
		{
			OdbcCommand command;
			OdbcConnection con;
			OdbcTransaction trans = null;
			string sql ="insert into categories(category_id, category) values(?,?) ";
			try
			{
				Console.WriteLine("Insert a new Category");
				Console.Write("Category id: ");
				int id = Convert.ToInt32(Console.ReadLine());
				Console.Write("Category: " );
				string cat = Console.ReadLine();
				Console.WriteLine();
				con = new OdbcConnection("DRIVER=Mimer;UID=MIMER_STORE;PWD=store;DATABASE=multi1");
				con.InfoMessage += new OdbcInfoMessageEventHandler(eeh.HandleInfoEvents);
				con.Open();
				trans = con.BeginTransaction(System.Data.IsolationLevel.Serializable);
				command = new OdbcCommand(sql, con,trans);
				//An alternative but equivalent approach
				//command = new OdbcCommand(sql, con);
				//command.Transaction=trans;
				OdbcParameter idParam = new OdbcParameter("id", OdbcType.Int);
				idParam.Value = id;
				command.Parameters.Add(idParam);
				command.Parameters.Add("id", cat);
				command.Prepare();
				command.ExecuteNonQuery();
				trans.Commit();
				con.Close();
			}
			catch(OdbcException oe)
			{

				eeh.ShowExceptions(oe);
				try
				{
					trans.Rollback();
				}
				catch(OdbcException oe2)
				{
					eeh.ShowExceptions(oe2);
				}
			}
			catch(FormatException fe)
			{
				Console.WriteLine(fe.Message);
			}
		}
	}
}
